//
//  SwizzleExampleClass.m
//  swizzlingObjC
//
//  Created by Kyryl Horbushko on 1/10/21.
//

#import "SwizzleExampleClass.h"
#import <objc/runtime.h>

static IMP __original_Method_Imp;
int _replacement_Method(id self, SEL _cmd)
{
    assert([NSStringFromSelector(_cmd) isEqualToString:@"originalMethod"]);
        //code
    int returnValue = ((int(*)(id,SEL))__original_Method_Imp)(self, _cmd);
    return returnValue + 1;
}

@implementation SwizzleExampleClass
- (void) swizzleExample //call me to swizzle
{
    Method m = class_getInstanceMethod([self class],
                                       @selector(originalMethod));
    __original_Method_Imp = method_setImplementation(m,
                                                     (IMP)_replacement_Method);
}
- (int) originalMethod
{
        //code
    assert([NSStringFromSelector(_cmd) isEqualToString:@"originalMethod"]);
    return 1;
}
@end
